        name    int24
        title   INT24 Critical Error Handler
 
        .model  small,c
        .code
        public  set24
save24  dd      0               ; previous contents of Int 24H

set24   proc    near            ; set Int 24H vector to point
                                ; to new critical error handler
 
        push    ds              ; save segment registers
        push    es
 
        mov     ax,3524h        ; get address of previous
        int     21h             ; INT 24H handler and save it
 
        mov     word ptr cs:save24,bx
        mov     word ptr cs:save24+2,es
 
        push    cs              ; set DS:DX to point to
        pop     ds              ; new INT 24H handler
        mov     dx,offset cs:int24
        mov     ax,2524h        ; then call MS-DOS to
        int     21h             ; set the INT 24H vector
 
        pop     es              ; restore segment registers
        pop     ds
        ret                     ; and return to caller
 
set24   endp
 
 
        public  res24
res24   proc    near            ; restore original contents
                                ; of Int 24H vector
 
        push    ds              ; save our data segment
        push    cs
        pop     ds
        mov     dx,offset cs:save24       ; put address of old handler
        mov     ax,2524h        ; back into INT 24H vector
        int     21h
 
        pop     ds              ; restore data segment
        ret                     ; and return to caller
 
res24   endp
 
;
; This is the replacement critical error handler.  It
; prompts the user for Abort, Retry, Ignore, or Fail and
; returns the appropriate code to the MS-DOS kernel.
; 
int24   proc    far             ; entered from MS-DOS kernel
 
        test    ah,80h
        jnz     int24a
        mov     al,2
        iret                    ; exit critical error handler
int24a:
        pushf
        jmp     cs:save24
int24   endp
 
        end
