include strucs.inc
;----------------------------------------------------------------------
; STRNDX: General purpose string search routine
;
; Call with:    DS:SI = pattern address
;               BX    = pattern length 
;               ES:DI = address of string to be searched
;               DX    = length of string to be searched
;
; Returns:      CY    = True if no match 
;               or
;               CY    = False if match, and 
;               ES:DI = pointer to match for pattern
;                       string within searched string
;----------------------------------------------------------------------
        .model  small,c
        .code
foff    proc    uses    si di, str:FAR PTR,off:NEAR PTR,place:NEAR PTR,len:WORD
        mov     si,off
        les     di,str
        mov     bx,4
        mov     dx,len
        push    bp
        call    strndx
        pop     bp
        jc      @F
        mov     bx,place
        mov     [bx],di
@@:     ret
foff    endp

strndx  proc

        mov     bp,si           ; save pattern offset
        dec     bx              ; decr. pattern length by one
        cld

sndx1:  mov     si,bp           ; AL := first char of pattern
        lodsb
        mov     cx,dx           ; remaining searched string length
        repnz scasb             ; look for match on first char.

        jnz     sndx3           ; searched string exhausted, exit

        mov     dx,cx           ; save new string length
        mov     cx,bx           ; get pattern length - 1
        repz cmpsb              ; compare remainder of strings

        jz      sndx2           ; everything matched

        add     di,cx           ; no match, restore string addr
        sub     di,bx           ; advanced by one char.

        cmp     dx,bx           ; searched string exhausted?
        ja      sndx1           ; some string left, try again
        jmp     sndx3           ; no match, jump to return 

sndx2:  sub     di,bx           ; match found, let
        dec     di              ; ES:DI = matched string addr.
        clc                     ; and return CY=False
        ret

sndx3:  stc                     ; no match, return CY=True
        ret

strndx  endp
END
