@echo off
rem Startup batch file for Wssindex.

rem Edit as necessary for your configuration.  Lines beginning with 'rem'
rem are comments.  Removing them will slightly decrease execution time.

rem Delete this block of lines after inserting the appropriate paths.
	echo You must edit startwss.bat to insert paths appropriate for your setup.
	goto Done

rem Sample batch file for starting Wssindex.  Arguments are configuration
rem and database file names.

rem This batch file assumes that you have sufficient environment space.
rem If not, you may end up with a strange prompt.

rem The next 2 linesare only for Wssindex/Extended.  Wssindex/Extended is
rem unable to change the prompt in a DOS shell, so the 2 SETs save the old
rem prompt and then redefine the prompt.

	set oldprompt=%PROMPT%
	set prompt=Type 'EXIT' to return to Wssindex$_%PROMPT%

rem These two SETs define default configuration and database file names.
rem Change as necessary for your disk directory structure.  Or, put the
rem fully qualified file names in the program invocation and omit these
rem environment variables entirely.

	set wssicnf=c:\wssindex\wssindex.cnf
	set wssidir=c:\wssindex\wssindex.dir

rem This command starts Wssindex.  If you always use the same configuration
rem file, put its name in place of %1 and change %2 to %1.  Similarly, if you
rem have only one database file, it may be explicitly named as the last
rem argument.  An example of these changes is included as a remark before
rem the command to start Wssindex.  Replace 'wssindex' with the actual name
rem of the executable, which will be either WSSInnn, WSSInnnD or WSDPMnnn,
rem where nnn is the rem version number.  (Of course, you may also rename the
rem executable file to WSSINDEX.EXE.)

	wssindex %1 %2

rem Restore the original prompt and clean up the environment variables used
	set wssicnf=
	set wssidir=
	set prompt=%OLDPROMPT%
	set oldprompt=

:Done
